<?php

  class ot_payolution_invoice_fee {
    var $title, $output, $mode;

    function ot_payolution_invoice_fee() {
      $this->code = 'ot_payolution_invoice_fee';
      $this->title = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TITLE;
      $this->description = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_DESCRIPTION;
      $this->enabled = ((MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS == 'true') ? true : false);
      $this->mode = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_MODE; 
      $this->sort_order = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_SORT_ORDER;
      $this->output = array();
    }

    function calculateDisagio() {
       global $order;
       $disagio = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE / 100.00;
       $gross = $order->info['total'];
       $tax = zen_get_tax_rate(MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']) / 100.00;
       $cost = ($disagio * $gross) / (1 - ($disagio * (1 + $tax)));
       return $cost;
    }

    function process() {
      global $order, $currencies;

      if (MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS == 'true') {

        //check if payment method is payolution invoice. If yes, check if invoice fee is possible.
        if ($_SESSION['payment'] == 'xml_payolution_invoice') {
          //process installed shipping modules
            if($this->mode == 'flat') {
                $payolution_invoice_cost = MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE;
            } else {
                $payolution_invoice_cost = $this->calculateDisagio(); 
            }
            $payolution_invoice_tax = zen_get_tax_rate(MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
            $payolution_invoice_tax_description = zen_get_tax_description(MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
        if ($_SESSION['customers_status']['customers_status_show_price_tax'] == 1) {
            $order->info['tax'] += zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax)-$payolution_invoice_cost;
            $order->info['tax_groups'][TAX_ADD_TAX . "$payolution_invoice_tax_description"] += zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax)-$payolution_invoice_cost;
            $order->info['total'] += $payolution_invoice_cost + (zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax)-$payolution_invoice_cost);
            $payolution_invoice_cost_value= zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax);
            $payolution_invoice_cost= $currencies->format($payolution_invoice_cost_value);
        }
        if ($_SESSION['customers_status']['customers_status_show_price_tax'] == 0 && $_SESSION['customers_status']['customers_status_add_tax_ot'] == 1) {
            $order->info['tax'] += zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax)-$payolution_invoice_cost;
            $order->info['tax_groups'][TAX_NO_TAX . "$payolution_invoice_tax_description"] += zen_add_tax($payolution_invoice_cost, $payolution_invoice_tax)-$payolution_invoice_cost;
            $payolution_invoice_cost_value=$payolution_invoice_cost;
            $payolution_invoice_cost= $currencies->format($payolution_invoice_cost);
            $order->info['subtotal'] += $payolution_invoice_cost_value;
            $order->info['total'] += $payolution_invoice_cost_value;
        }
        if (!$payolution_invoice_cost_value) {
           $payolution_invoice_cost_value=$payolution_invoice_cost;
           $payolution_invoice_cost= $currencies->format($payolution_invoice_cost);
           $order->info['total'] += $payolution_invoice_cost_value;
        }
            $this->output[] = array('title' => $this->title . ':',
                                    'text' => $payolution_invoice_cost,
                                    'value' => $payolution_invoice_cost_value);
        }
      }
    }

    function check() {
    	global $db;
      	if (!isset($this->_check)) {
        	$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS'");
        	$this->_check = $check_query->RecordCount();
      	}
      	return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS', 'MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_SORT_ORDER', 'MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_MODE', 'MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE','MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS');
    }

    function install() {
    	global $db;
    	include(DIR_FS_CATALOG_LANGUAGES . $_SESSION['language'] . '/modules/order_total/ot_payolution_invoice_fee.php');
    	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS', 'true', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS_TITLE') . "', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_STATUS_DESC') . "', '6', '0', 'zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added) values ('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_SORT_ORDER', '35', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_SORT_ORDER_TITLE') . "', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_SORT_ORDER_DESC') . "', '6', '0', now())");
      	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added) values ('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE', '10.00', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE_TITLE') . "', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_VALUE_DESC') . "', '6', '0', now())");
      	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_MODE', 'flat', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_MODE_TITLE') . "', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_MODE_DESC') . "', '6', '0', 'zen_cfg_select_option(array(\'flat\', \'disagio\'), ', now())");
    	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS', '0', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS_TITLE') . "', '" . @constant('MODULE_ORDER_TOTAL_PAYOLUTION_INVOICE_FEE_TAX_CLASS_DESC') . "', '6', '0', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
    }

    function remove() {
    	global $db;
      	$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
