<?php
/*
  Payment modules - On XML Plugin Base Class
*/

require_once dirname(__FILE__) ."/base_plugin.class.inc";
require_once dirname(__FILE__) ."/xml_integrator.class.inc";

class based_on_xml extends base_plugin
{
	function based_on_xml()
	{
		$this->request_parameters = @ new xml_integrator();
        $this->payment_mode = MODE_XML;
		
		parent::base_plugin();
	}
	
	function is_request_success($response)
	{
		global $messageStack;
		try
		{
			$this->response_parameters = @ new SimpleXMLELement($response);
			return $this->response_sync_success();
		}
		catch (Exception $exc)
		{
			$messageStack->add_session('checkout_payment', 'Could not parse response');
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
		}
		return false;
	}
	
	function cancel_request ()
	{
		global $messageStack;
		$response_message = $this->response_parameters->xpath(XPATH_RETURN_SYNC_RESPONSE_MESSAGE);
		$messageStack->add_session('checkout_payment', (string)$response_message[0]);
		zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
	}

	function response_sync_success ()
	{
		$response_result = $this->response_parameters->xpath(XPATH_RESULT_SYNC_RESPONSE);
		$response_return = $this->response_parameters->xpath(XPATH_RETURN_SYNC_RESPONSE);

		$result_ack = ((string) $response_result[0] == ACKNOWLEDGE_PROCESSING_RESULT);
		$return_waiting = ((string) $response_return[0] == ACKNOWLEDGE_RETURN_CODE_WAITING);
		$return_succeded = ((string) $response_return[0] == ACKNOWLEDGE_RETURN_CODE_SUCCESS);

		return $result_ack && in_array($response_return[0], $this->acknowledge_return_code);
	}

	function response_async_success ()
	{
		$response_result = $this->response_parameters->xpath(XPATH_RESULT_ASYNC_RESPONSE);
		$response_return = $this->response_parameters->xpath(XPATH_RETURN_ASYNC_RESPONSE);
		
		$result_ack = ((string) $response_result[0] == ACKNOWLEDGE_PROCESSING_RESULT);
		$return_succeeded = ((string) $response_return[0] == ACKNOWLEDGE_RETURN_CODE_SUCCESS);
		
		return $result_ack || $return_succeeded;
	}
	
	function get_redirect_url (SimpleXMLElement $xml)
	{
		$complete_url = array();
		$this->parameters_to_post = array();
		$this->main_redirect_url = $this->parse_redirect_url($xml);
		
		foreach ($xml->xpath(XPATH_RESPONSE_PARAMETERS) as $parameter)
		{
			$key = (string) $parameter->attributes();
			$value = (string) $parameter;
			$complete_url [] = $key. "=" .((preg_match(REGEX_COMPLETE_URL, $value)) ? urlencode($value) : $value);
			$this->parameters_to_post[$key] = $value;
		}
		$this->complete_redirect_url = $this->main_redirect_url. "?" .implode("&", $complete_url);
		
		return $this->complete_redirect_url;
	}

	function parse_redirect_url ($xml)
	{
		$redirect_url = $xml->xpath(XPATH_RESPONSE_URLREDIRECTEDTO);
		if (empty($redirect_url))
		{
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' .$this->code. '&payment_error_type=TECHNICAL_ERROR', 'SSL', true, false));
		}
		return (string) $redirect_url[0];
	}

    /**
	 * This method is called after the payment has been done whether succesful or not.
	 * It returns the url string that requested by payment gateway server.
	 */
	function get_shop_url ($print = true)
	{
		global $message_stack;
		$osc_session_name = "XTCsid";
		$sessionid = $_GET['sessionid'];
		$xml_receive = $this->get_async_xml_response($param_name);
		$this->response_parameters = null;
		
		create_log("Step 3: Information about result of async payment",
			"", "Received request (Request contains final status of the asynchronous payment)",
			$param_name ,$xml_receive,
			"Complete POST received", print_r($_POST, true)
		);
		/*
		create_log("=Step 3: Information about result of async payment= \n\n"
			."==Received request (Request contains final status of the asynchronous payment) == "
			.$xml_receive);
		*/
		try
		{
			$this->response_parameters = @ new SimpleXMLElement($xml_receive);
			if (isset($_POST['response']))
			{
				$sessionid = $this->response_parameters->xpath(XPATH_FRONTEND_SESSIONID);
				$sessionid = (string) $sessionid[0];
			}
		}
		catch (Exception $exc)
		{
			$error_message = urlencode($exc->getMessage());
		}

		if (!is_null($this->response_parameters) && $this->response_async_success())
		{
			$page = (!empty($_GET[COOKIEKEY_ALTERNATEURL_SUCCESS])) ? 
				$_GET[COOKIEKEY_ALTERNATEURL_SUCCESS] : FILENAME_RESPONSE_REDIRECT;
			
			$get_var_str = $osc_session_name . '=' . $sessionid .
				'&CLEARING_DESCRIPTOR=' . urlencode($this->response_parameters->Transaction->Payment->Clearing->Descriptor) .
				'&CLEARING_AMOUNT=' . $this->response_parameters->Transaction->Payment->Clearing->Amount .
				'&CLEARING_CURRENCY=' . $this->response_parameters->Transaction->Payment->Clearing->Currency .
				'&PROCESSING_CODE=' . $this->response_parameters->Transaction->Processing->attributes()->code .
				'&PROCESSING_RETURN_CODE=' . $this->response_parameters->Transaction->Processing->Return->attributes()->code .
				'&PROCESSING_TIMESTAMP=' . urlencode($this->response_parameters->Transaction->Processing->Timestamp) .
				'&PROCESSING_RETURN=' . urlencode($this->response_parameters->Transaction->Processing->Return) .
				'&payment=success';
		}
		else
		{
			$has_response = !is_null($this->response_parameters);
			if ($has_response)
			{ 
				$error_message = $this->response_parameters->Transaction->Processing->Return->attributes()->code;
			}
			
			$page = FILENAME_CHECKOUT_PAYMENT;
			$page = (!empty($_GET[COOKIEKEY_ALTERNATEURL_FAILED])) ? 
				$_GET[COOKIEKEY_ALTERNATEURL_FAILED] .$error_message : $page;
			$messageStack->add_session('checkout_payment', $error_message);
			$get_var_str = $osc_session_name . '=' . $sessionid .
				'&payment_error=' . $_GET['payment_module'] .
				'&payment_error_type=TRANSACTION_ERROR' .
				'&payment_error_code=' . $error_message;
		}

		header("Content-Type: text/plain; charset=utf-8");
		$url_complete = zen_href_link($page, $get_var_str. '&payment_module=' .$this->code, "SSL", false);
		create_log(null, "", "Response (responding with the url where the user should be redirected to)", 
			"URL", $url_complete,
			"Waiting for the shopper to return to shop ... ");
		
		if ($print)
		{
			echo $url_complete;
		}
		else
		{
			return $url_complete;
		}
	}
	
	function get_async_xml_response(&$_response_param_name='')
	{
		$xml_receive = '';
		if (isset($_POST['response']))
	    {
	        $xml_receive = urldecode($_POST['response']);
	        $_response_param_name = 'response';
	    }
	    elseif (isset($_POST['message']))
	    {
	        $xml_receive = stripslashes($_POST['message']);
	        $_response_param_name = 'message';
	    }
	    elseif (isset($_POST['responseXML']))
	    {
	        $xml_receive = stripslashes($_POST['responseXML']);
	        $_response_param_name = 'responseXML';
	    }
	    
	    return $xml_receive;
	}
}
?>
